package com.gic.enterprise.context;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
/**
 * session
 * @ClassName: RequestContext 
 * @Description:  
 * @author guojuxing 
 * @date 2020/9/15 10:16 AM 
 */
public class RequestContext {
    private static final Logger log = LogManager.getLogger(RequestContext.class);
    private ThreadLocal<HttpServletRequest> requestThreadLocal = new ThreadLocal<>();
    private ThreadLocal<HttpServletResponse> responseThreadLocal = new ThreadLocal<>();
    private static RequestContext requestContext = null;

    public static RequestContext getContext(){
        if(requestContext == null){
            synchronized (RequestContext.class){
                if(requestContext == null){
                    try{
                        requestContext = new RequestContext();
                    }catch (Exception e){
                        log.info("创建对象失败");
                    }
                }
            }
        }
        return requestContext;
    }

    public void init(HttpServletRequest request, HttpServletResponse response){
        requestThreadLocal.set(request);
        responseThreadLocal.set(response);
    }

    public void destroy(){
        requestThreadLocal.remove();
        responseThreadLocal.remove();
    }

    public HttpServletRequest getRequest(){
        return requestThreadLocal.get();
    }

    public HttpServletResponse getResponse(){
        return responseThreadLocal.get();
    }
}
