package com.gic.enterprise.utils;

import java.io.Serializable;
import java.util.Set;

import com.gic.enterprise.base.*;

/**
 * session
 * @ClassName: UserDetail 
 * @Description:  
 * @author guojuxing 
 * @date 2020/9/15 10:15 AM 
 */
public class UserDetail implements Serializable {
    private Integer userId = 2222;
    private UserInfo userInfo;
    private EnterpriseInfo enterpriseInfo;

    /**
     * 用户登陆所有拥有的菜单权限，用于权限拦截，存放menu_id
     */
    private Set<Integer> menuIdSet;

    /**
     * 资源组-用户域的配置信息
     */
    private CustomUserInfo customUserInfo;

    /**
     * 资源组-商品资源
     */
    private GoodsResourceInfo goodsResourceInfo;

    /**
     * 资源组-门店资源
     */
    private StoreResourceInfo storeResourceInfo;

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Integer getEnterpriseId() {
        return enterpriseInfo.getEnterpriseId();
    }

    public UserInfo getUserInfo() {
        return userInfo;
    }

    public void setUserInfo(UserInfo userInfo) {
        this.userInfo = userInfo;
    }

    public EnterpriseInfo getEnterpriseInfo() {
        return enterpriseInfo;
    }

    public void setEnterpriseInfo(EnterpriseInfo enterpriseInfo) {
        this.enterpriseInfo = enterpriseInfo;
    }



    public Set<Integer> getMenuIdSet() {
        return menuIdSet;
    }

    public UserDetail setMenuIdSet(Set<Integer> menuIdSet) {
        this.menuIdSet = menuIdSet;
        return this;
    }

    public CustomUserInfo getCustomUserInfo() {
        return customUserInfo;
    }

    public UserDetail setCustomUserInfo(CustomUserInfo customUserInfo) {
        this.customUserInfo = customUserInfo;
        return this;
    }

    public GoodsResourceInfo getGoodsResourceInfo() {
        return goodsResourceInfo;
    }

    public UserDetail setGoodsResourceInfo(GoodsResourceInfo goodsResourceInfo) {
        this.goodsResourceInfo = goodsResourceInfo;
        return this;
    }

    public StoreResourceInfo getStoreResourceInfo() {
        return storeResourceInfo;
    }

    /**
     * 资源组门店选择器ID
     * @return
     */
    public Long getStoreResourceId() {
        if (storeResourceInfo != null) {
            if (storeResourceInfo.getStoreResourceId() != null) {
                return Long.valueOf(storeResourceInfo.getStoreResourceId());
            }
        }
        return null;
    }

    public UserDetail setStoreResourceInfo(StoreResourceInfo storeResourceInfo) {
        this.storeResourceInfo = storeResourceInfo;
        return this;
    }
}
