package com.gic.enterprise.jsonseralizer;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

import java.io.IOException;
/**
 * 数据处理
 * @ClassName: AbstractJsonSerializer 
 * @Description:  
 * @author guojuxing 
 * @date 2020/9/15 10:11 AM 
 */
public abstract class AbstractJsonSerializer extends JsonSerializer<String> {

    /**
     * 序列化数据
     * @Title: serializerData 
     * @Description:
     * @author guojuxing
     * @param value 
     * @return  java.lang.String 
     */
    protected abstract String serializerData(String value);

    @Override
    public void serialize(String o, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException, JsonProcessingException {
        if(o != null){
            String result = this.serializerData(o);
            jsonGenerator.writeString(result);
        }
    }
}
