package com.gic.enterprise.jsonseralizer;


import com.gic.enterprise.utils.UserDetail;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.redis.data.util.RedisUtil;
import org.apache.commons.lang3.StringUtils;
import org.redisson.api.RBucket;
import org.redisson.api.RedissonClient;
/**
 * 加密
 * @ClassName: EncryptJsonSerializer 
 * @Description:  
 * @author guojuxing 
 * @date 2020/9/15 10:45 AM 
 */
public class EncryptJsonSerializer extends AbstractJsonSerializer {

    @Override
    protected String serializerData(String text){
        if (StringUtils.isEmpty(text)) {
            return text;
        }
        if (ensureRiskMode()) {
            // 风险模式
            return text;
        } else {
            // 安全模式
            return encrypt(text);
        }
    }

    private boolean ensureRiskMode() {
        UserDetail userDetail = UserDetailUtils.getUserDetail();
        String redisKey = "enterprise:riskMode:" + userDetail.getEnterpriseId() + ":" + userDetail.getUserId();
        RedissonClient redisClient = RedisUtil.getRedisClient();
        RBucket<Object> bucket = redisClient.getBucket(redisKey);
        return bucket.get() != null;
    }

    private String encrypt(String data) {
        if (StringUtils.isBlank(data)) {
            return data;
        }
        //手机号或者会员卡号 第5-8位用*代替
        int length = data.length();
        if (length > 7) {
            return data.substring(0, 3) + "****" + data.substring(7);
        } else if (length > 4) {
            return data.substring(0, 3) + "****";
        } else {
            return "****";
        }
    }
}
